/* Name: main.c

 */

#define F_CPU   1000000L    /* vidinis */



#define CH0_CLEAR (pinlevelB &= ~(1 << PB0)) // map CH0 to PB0
#define CH1_CLEAR (pinlevelB &= ~(1 << PB1)) // map CH1 to PB1
#define CH2_CLEAR (pinlevelB &= ~(1 << PB2)) // map CH2 to PB3
#define PORTB_MASK  (1 << PB0)|(1 << PB1)|(1 << PB2)

#include <avr/io.h>
#include <avr/interrupt.h>
// #include <util\delay.h>
#include <avr\sleep.h>

volatile char i,j;
unsigned char compare[3];
volatile unsigned char compbuff[3];

volatile  signed char r,g,b;

void initAll(void)				
{
	DDRB=0x07;		// B0, B1, B2
	TCCR0=_BV(CS01) | _BV(CS00); // prescaleris CLK/64
	
	 TIMSK = _BV (TOIE0);
    sei ();
}

/* ------------------------------------------------------------------------- */

int	main(void)
{
  static unsigned char softcount=0xFF;
  static unsigned char pinlevelB=PORTB_MASK;

    initAll();			// Sutvarkom portu kryptis
	
	compare[0]=0x80;
	compare[1]=0x80;
	compare[2]=0x80;
	compbuff[0]=0x80;
	compbuff[1]=0x80;
	compbuff[2]=0x80;
	r=-3;
	g=2;
	b=1;
	
	for(;;){	/* main event loop */
		// _delay_ms(20);
		// sleep_mode();
		PORTB = pinlevelB;
		if(++softcount == 0){         // increment modulo 256 counter and update
                                // the compare values only when counter = 0.
		compare[0] = compbuff[0];   // verbose code for speed
		compare[1] = compbuff[1];
		compare[2] = compbuff[2];  
		pinlevelB=PORTB_MASK;
		}
      // clear port pin on compare match (executed on next interrupt)
		if(compare[0] == softcount) CH0_CLEAR;
		if(compare[1] == softcount) CH1_CLEAR;
		if(compare[2] == softcount) CH2_CLEAR;
		 
        }
}


/* ------------------------------------------------------------------------- */
//---pertraukimas pagal taimeri 0----
ISR(TIMER0_OVF0_vect) //timer overflow vector
{

	if (compbuff[0]<4 && r<0)  { r=-r; } else if (compbuff[0]>251 && r>0)  { r=-r; }
	if (compbuff[1]<4 && g<0)  { g=-g; } else if (compbuff[1]>251 && g>0)  { g=-g; }
	if (compbuff[2]<4 && b<0)  { b=-b; } else if (compbuff[2]>251 && b>0)  { b=-b; }

	compbuff[0] = compbuff[0]+r;
	compbuff[1] = compbuff[1]+g;
	compbuff[2] = compbuff[2]+b;

}
